package org.dromara.work.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.RequiredArgsConstructor;
import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.mybatis.core.page.PageQuery;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.work.domain.TpOrderCd;
import org.dromara.work.domain.bo.TpOrderCdBo;
import org.dromara.work.domain.vo.TpOrderCdVo;
import org.dromara.work.mapper.TpOrderCdMapper;
import org.dromara.work.service.ITpOrderCdService;
import org.springframework.stereotype.Service;

import java.util.Collection;
import java.util.List;
import java.util.Map;

/**
 * 拆单记录Service业务层处理
 *
 * @author Maosw
 * @date 2024-08-12
 */
@RequiredArgsConstructor
@Service
public class TpOrderCdServiceImpl implements ITpOrderCdService {

    private final TpOrderCdMapper baseMapper;

    /**
     * 查询拆单记录
     *
     * @param id 主键
     * @return 拆单记录
     */
    @Override
    public TpOrderCdVo queryById(Long id){
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询拆单记录列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 拆单记录分页列表
     */
    @Override
    public TableDataInfo<TpOrderCdVo> queryPageList(TpOrderCdBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<TpOrderCd> lqw = buildQueryWrapper(bo);
        Page<TpOrderCdVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的拆单记录列表
     *
     * @param bo 查询条件
     * @return 拆单记录列表
     */
    @Override
    public List<TpOrderCdVo> queryList(TpOrderCdBo bo) {
        LambdaQueryWrapper<TpOrderCd> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<TpOrderCd> buildQueryWrapper(TpOrderCdBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<TpOrderCd> lqw = Wrappers.lambdaQuery();
        lqw.eq(bo.getOid() != null, TpOrderCd::getOid, bo.getOid());
        lqw.eq(bo.getPrice() != null, TpOrderCd::getPrice, bo.getPrice());
        lqw.eq(bo.getAddTime() != null, TpOrderCd::getAddTime, bo.getAddTime());
        lqw.eq(bo.getAddUser() != null, TpOrderCd::getAddUser, bo.getAddUser());
        return lqw;
    }

    /**
     * 新增拆单记录
     *
     * @param bo 拆单记录
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(TpOrderCdBo bo) {
        TpOrderCd add = MapstructUtils.convert(bo, TpOrderCd.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改拆单记录
     *
     * @param bo 拆单记录
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(TpOrderCdBo bo) {
        TpOrderCd update = MapstructUtils.convert(bo, TpOrderCd.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(TpOrderCd entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除拆单记录信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }
}
